package rozdeleniobrazku;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import javax.swing.JComponent;

/**
 *
 * @author luboš
 */
public class ImageCut extends JComponent {
    
    private BufferedImage image;
    private Dimension size;
    private int columns = 1;
    private int rows = 1;
    
    public ImageCut(BufferedImage image) {
        this.image = image;
        size = new Dimension(image.getWidth(), image.getHeight());
    }
    
    @Override
    protected void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D)g;
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                            RenderingHints.VALUE_ANTIALIAS_ON);
        g2.drawImage(image, 0, 0, this);
        g.setColor(Color.WHITE);
        if (columns > 1) {
            int columnStep = size.width / columns;
            int margin = (size.width - (columnStep * columns)) / 2;
            for (int i = 1; i < columns; i++) {
                g.drawLine(columnStep * i + margin, 0, columnStep * i + margin, getHeight());
            }
        }
        if (rows > 1) {
            int rowStep = size.height / rows;
            int margin = (size.height - (rowStep * rows)) / 2;
            for (int i = 1; i < rows; i++) {
                g.drawLine(0, rowStep * i + margin, getWidth(), rowStep * i + margin);
            }
        }
    }
    
    public void setColumns(int columns) {
        if (columns > 0 && columns < 11) {
            this.columns = columns;
            this.repaint();
        }
    }
    
    public void setRows(int rows) {
        if (rows > 0 && rows < 11) {
            this.rows = rows;
            this.repaint();
        }
    }
    
    @Override
    public Dimension getPreferredSize()
    {
        return size;
    }
}
